PFont Courier255;
String letters = "";
float a;
int colors = #36DE28;
int IDS;
boolean has_ID = false;
boolean blow = false;

int global_val = 0;
int[] avg_y; //array
int tt = 10;


import oscP5.*;
import processing.serial.*;

Serial serial;
OscSerial osc;
String serialName = "/dev/cu.usbmodem1421";


void setup() {
  size(displayWidth, displayHeight, P3D);
  Courier255 = loadFont("Courier255.vlw");
  textFont(Courier255);
  textAlign(CENTER, CENTER);
  background(000);

  println(Serial.list());

  avg_y = new int[tt];

  serial = new Serial(this, serialName, 115200);
  osc = new OscSerial(this, serial);
  osc.plug(this, "stampID", "/ID");
  osc.plug(this, "pressure", "/P");
  osc.plug(this, "IRVal", "/I");
  //osc.plug(this, "Blow", "/Blow");
}

void draw() {

  if (IDS == 0x64352153 && has_ID==true) letters = letters + "A";
  if (IDS == 0x4031D53 && has_ID==true) letters = letters + "B";
  if (IDS == 0x74FC1D53 && has_ID==true) letters = letters + "C";
  if (IDS == 0x54811D53 && has_ID==true) letters = letters + "D";
  if (IDS == 0xE4FB1D53 && has_ID==true) letters = letters + "E";
  if (IDS == 0x647D2053 && has_ID==true) letters = letters + "F";
  if (IDS == 0x54DA2153 && has_ID==true) letters = letters + "G";
  if (IDS == 0x4832053 && has_ID==true) letters = letters + "H";
  if (IDS == 0x14411E53 && has_ID==true) letters = letters + "I";
  if (IDS == 0xD4851A53 && has_ID==true) letters = letters + "J";
  if (IDS == 0x34981F53 && has_ID==true) letters = letters + "K";
  if (IDS == 0xD4141F53 && has_ID==true) letters = letters + "L";
  if (IDS == 0x74061E53 && has_ID==true) letters = letters + "M";
  if (IDS == 0x74B92053 && has_ID==true) letters = letters + "N";
  if (IDS == 0xA4841E53 && has_ID==true) letters = letters + "O";
  if (IDS == 0x54281C53 && has_ID==true) letters = letters + "P";

  if (blow) {
    letters = "";
    blow = false;
  }

  if (global_val > 400) {
    textSize(500);
  } else {
    textSize(100 + global_val);
  }

  a += 0.1;
  //  int size = 100 + global_val;
  background(000);

  pushMatrix();
  scale(-1, 1);
  ortho(); 
  translate(-width/4, height/2, 0);
  rotate(-PI/2);
  //rotateY(a);
  //rotateZ(a);
  //rotateX(a);
  fill(colors);
  //float cursorPosition1 = textWidth(letters);
  //line(cursorPosition1, 0, cursorPosition1, 100);
  text(letters, 0, 0, 0);
  popMatrix();

  pushMatrix();
  scale(1, 1);
  ortho(); 
  translate(3*width/4, height/2, 0);
  rotate(-PI/2);
  //rotateY(a);
  //rotateZ(a);
  //rotateX(a);
  fill(colors);
  // float cursorPosition2 = textWidth(letters);
  // line(cursorPosition2, 0, cursorPosition2, 100); 
  text(letters, 0, 0);
  popMatrix();

  if ( has_ID ) {
    IDS = 0;
  }
  has_ID = false;
}
//}

void plugTest(int ID) {
  println("Plugged from /pattern: " + ID);
}

void stampID(int ID) {
  print( "stamp @ 0x");
  println( hex(ID) );
  IDS = ID;
}

void pressure(int p1, int p2, int p3, int p4, int blow) {
  if ( p1 + p2 + p3 + p4 > 200) {
    // println( "pressure @ " + p1 + " - " + p2 + " - " + p3 + " - " + p4 + "blow:" + blow);
    has_ID = true;
  }
}

void IRVal(int val1, int val2) {

  // println( "IRVal1 @ " + val1 + " - " + val2 );

  for ( int i = 0; i < tt - 1; i++ ) {
    avg_y[i] = avg_y[i+1];  // shift the data one grid left
  }
  avg_y[tt - 1] = ( val1 + val2 )/4;  // newest data into the rightest grid

  long sum = 0;
  for ( int i = 0; i < tt; i++) {
    sum+=avg_y[i];
  }

  int avg = (int)(sum / tt);  // averaging it

  global_val = avg;
}

//void Blow(int val) {

//  println( "Blow @ " + val);
//  if (val == 1 ) {
//    blow = true;
//  }
//}

// Any unplugged message will come here
void oscEvent(OscMessage theMessage) {
  if (! theMessage.isPlugged()) {
    println("invalid Message: " + theMessage);
  }
}

void keyPressed() {
  if (key == BACKSPACE) {
    if (letters.length() > 0) {
      letters = letters.substring(0, letters.length()-1);
    }
    //} else if (textWidth(letters+key) < displayHeight) {
    // letters = letters + key;
    //}
    //println(textWidth(letters+key));
  }
}